GGRadio = GGRadio or {}

if GGRadio and IsValid( GGRadio.Radio ) then
	if GGRadio.Radio:IsOnline() then
		GGRadio.Radio:Stop()
	end
end

GGRadio.StreamURL = GGRadio.StreamURL or "http://sv.ggradio.net:8000/stream"
GGRadio.Cooldown = GGRadio.Cooldown or 5 --Anti spam, button cooldown for playing radio in seconds (Default: 120)
GGRadio.Status = GGRadio.Status or 0
GGRadio.Radio = GGRadio.Radio or nil
GGRadio.RadioVolume = GGRadio.RadioVolume or 1
GGRadio.CanPress = GGRadio.CanPress or true

hook.Add( "OnPlayerChat", "GGRadio_Chat", function( player, strText, bTeamOnly, bPlayerIsDead )
	if player == LocalPlayer() and strText == "!radio" then
		chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Opened radio!" )
		GGRadio:Open()
		return true
	end
	
	if player == LocalPlayer() and strText == "!radio on" then
		chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Started radio!" )
		GGRadio.PlayURL( GGRadio.StreamURL )
		return true
	end
	
	if player == LocalPlayer() and strText == "!radio off" then
		chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Stopped radio!" )
		GGRadio.PauseURL()
		return true
	end
	
	local str = string.Explode( " ", strText )
	local count = table.Count( str )
	if count > 2 then return end
	if player == LocalPlayer() and str[1] == "!radiovolume" then
		if count == 1 then chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "You forgot the number!" ) return true end
		if not tonumber( str[2] ) then chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "That's not a number!" ) return true end
		chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Volume set to " .. str[2] .. "!" )
		GGRadio.RadioVolume = str[2] / 100
		GGRadio.Radio:SetVolume( GGRadio.RadioVolume )
		return true
	end
end )

concommand.Add( "radiovolume", function( ply, cmd, args, argStr )
	if not tonumber( args[1] ) then return end
	chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Volume set to " .. args[1] .. "!" )
	GGRadio.RadioVolume = args[1] / 100
	GGRadio.Radio:SetVolume( GGRadio.RadioVolume )
end )

concommand.Add( "radio", function( ply )
	chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Opened radio!" )
	GGRadio:Open()	
end )

function GGRadio:Open()
	if not IsValid( GGRadio.Frame ) then
		GGRadio:Create()
	end
	
	GGRadio.Frame:SetVisible( true )
end

function GGRadio:Close()
	if not IsValid( GGRadio.Frame ) then
		GGRadio:Create()
		GGRadio.Frame:SetVisible( false )
		return
	end
	
	local x, y = GGRadio.Frame:GetPos()
	cookie.Set( "GGRadio_PosX", x )	
	cookie.Set( "GGRadio_PosY", y )	
	
	GGRadio.Frame:SetVisible( false )
end

function GGRadio.PlayURL( url )
	if GGRadio and IsValid( GGRadio.Radio ) then
		if GGRadio.Radio:IsOnline() then
			return
		end
	end

	GGRadio:Open()
	GGRadio:Close()
	
	GGRadio.Play:SetDisabled( true )
	GGRadio.Play:SetText( "Pause" )

	timer.Simple( GGRadio.Cooldown, function() if IsValid( GGRadio.Play ) then GGRadio.CanPress = true GGRadio.Play:SetDisabled( false ) end end )
	
	sound.PlayURL ( url, "mono", function( station )
		if ( IsValid( station ) ) then
			GGRadio.Radio = station
			GGRadio.Radio:Play()
			GGRadio.Radio:SetVolume( GGRadio.RadioVolume )
			GGRadio.Status = 1
			GGRadio.NextStatus = "Stop"
			chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Playing the stream!" )
		else
			chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Error playing, try again later!" )
		end
	end )
end

function GGRadio.PauseURL()
	GGRadio.Play:SetDisabled( true )
	GGRadio.Play:SetText( "Play" )
	timer.Simple( GGRadio.Cooldown, function() if IsValid( GGRadio.Play ) then GGRadio.CanPress = true GGRadio.Play:SetDisabled( false ) end end )
	chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Stopped the stream!" )
	GGRadio.Status = 0
	GGRadio.NextStatus = "Play"
	GGRadio.Radio:Stop()
end

function GGRadio:Create()
	GGRadio.Frame = vgui.Create( "DFrame" )
	GGRadio.Frame:SetPos( cookie.GetNumber( "GGRadio_PosX", 50 ), cookie.GetNumber( "GGRadio_PosY", ScrH() - 150 - 200 ) )	
	GGRadio.Frame:SetSize( 400, 125 )
	GGRadio.Frame:SetTitle( "" )
	GGRadio.Frame:SetDraggable( true )
	GGRadio.Frame:MakePopup()
	GGRadio.Frame.Paint = function( self )
		surface.SetDrawColor( 70, 70, 70, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), self:GetTall() )
		
		surface.SetDrawColor( 55, 55, 55, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), 30 )
	end
	GGRadio.Frame.btnMaxim:SetVisible( false )
	GGRadio.Frame.btnMinim:SetVisible( false )
	GGRadio.Frame.btnClose:SetVisible( false )
	GGRadio.Frame:SetKeyboardInputEnabled( false )
	
	GGRadio.Play = vgui.Create( "DButton", GGRadio.Frame )
	GGRadio.Play:SetPos( 0, 0 )
	GGRadio.Play:SetSize( 60, 30 )
	GGRadio.Play:SetText( "Play" )
	GGRadio.Play.UpdateColours = function()
		if GGRadio.Play:GetDisabled() then
			return GGRadio.Play:SetTextStyleColor( Color( 130, 130, 130 ) )
		end
		return GGRadio.Play:SetTextStyleColor( Color( 255, 255, 255 ) )
	end
	GGRadio.Play.Paint = function( self )
		surface.SetDrawColor( 65, 136, 250, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), 4 )
	end
	GGRadio.Play.DoClick = function()
		if GGRadio.Status == 0 then
			GGRadio.PlayURL( GGRadio.StreamURL )
		else
			GGRadio.PauseURL()
		end
	end
	
	GGRadio.Slider = vgui.Create( "Slider", GGRadio.Frame )
	GGRadio.Slider:SetPos( GGRadio.Frame:GetWide() / 2 - 200 / 2, 0 )
	GGRadio.Slider:SetSize( 200, 25 )
	GGRadio.Slider:SetText( "Volume" )
	GGRadio.Slider:SetMin( 0 )
	GGRadio.Slider:SetMax( 100 )
	GGRadio.Slider:SetDecimals( 0 )
	GGRadio.Slider:SetValue( GGRadio.RadioVolume * 100 )
	GGRadio.Slider.OnValueChanged = function( pnl, val )
		GGRadio.RadioVolume = val / 100
		if GGRadio then 
			if IsValid( GGRadio.Radio ) then
				GGRadio.Radio:SetVolume( GGRadio.RadioVolume )
			end
		end
	end
	GGRadio.Slider.TextArea:SetTextColor( Color( 255, 255, 255 ) )
	GGRadio.Slider:SizeToContents()
	
	GGRadio.Logo = vgui.Create( "DHTML", GGRadio.Frame )
	GGRadio.Logo:SetPos( 25, GGRadio.Frame:GetTall() - 20 - 50 )
	GGRadio.Logo:SetSize( GGRadio.Frame:GetWide() - 50, 50 )
	GGRadio.Logo:SetHTML([[
	<!DOCTYPE html>
	<html>
		<head>
			<style>
				body {
					overflow: hidden;
					width: 100%;
					height: 100%;
					background-color: transparent;
					margin: 0px;
				}

				#image {
					position: fixed;
					width: 100%;
					height: 100%;
					background-image: url(http://cdn.ggradio.net/apps/gmod/logo.png);
					background-size: 100% 100%;
				}
			</style>
		</head>
		<body>
			<div id="cursong"></div>
			<div id="image"></div>
		</body>
	</html>
	]])
	
	GGRadio.CloseBtn = vgui.Create( "DButton", GGRadio.Frame )
	GGRadio.CloseBtn:SetSize( 60, 30 )
	GGRadio.CloseBtn:SetPos( GGRadio.Frame:GetWide() - 60, 0 )
	GGRadio.CloseBtn:SetText( "Close" )
	GGRadio.CloseBtn.UpdateColours = function()
		return GGRadio.CloseBtn:SetTextStyleColor( Color( 255, 255, 255 ) )
	end
	GGRadio.CloseBtn.Paint = function( self )
		surface.SetDrawColor( 240, 65, 65, 255 )
		surface.DrawRect( 0, 0, self:GetWide(), 4 )
	end
	GGRadio.CloseBtn.DoClick = function()
		GGRadio:Close()
	end
	
	GGRadio:Close()
end

hook.Add( "Think", "GGRadio_ESC", function()
	if not IsValid( GGRadio.Frame ) then return end
	if input.IsKeyDown( KEY_ESCAPE ) and GGRadio.Frame:IsVisible() then
		GGRadio:Close()
	end	
end )

hook.Add( "OnScreenSizeChange", "SizeChanged", function( w, h )
	if w > cookie.GetNumber( "GGRadio_PosX", 0 ) or h > cookie.GetNumber( "GGRadio_PosY", 0 ) then  --If user drags it somehow out of screen/changes res, restore
		cookie.Set( "GGRadio_PosX", 0 )	
		cookie.Set( "GGRadio_PosY", 0 )	
	end
   GGRadio.Frame:Remove()
   GGRadio:Create()
end )