GGRadio = GGRadio or {}
GGRadio.Version = "1.2.2"
GGRadio.Outdated = false

if SERVER then

util.AddNetworkString( "GGRadio_SongChanged" )
util.AddNetworkString("GGRadio_NewPresenter")

GGRadio.CurPres = ""
GGRadio.OldPres = ""

timer.Create( "GGRadio_NewPresenter", 15, 0, function()
	if #player.GetAll() == 0 then return end

	http.Fetch( "https://api.tmw.media/ggradio/presenter/",
		function( body, len, headers, code )
			GGRadio.CurPres = string.Replace(body, "\n", "")
			if string.len(GGRadio.CurPres) > 200 then GGRadio.CurPres = "Presenter not available." end
			if(GGRadio.CurPres != GGRadio.OldPres) then
				GGRadio.OldPres = GGRadio.CurPres
				net.Start( "GGRadio_NewPresenter" )
					net.WriteString( GGRadio.CurPres )
				net.Broadcast()
			end
		end,
		function( error )
			
		end);
end)

GGRadio.CurSong = ""
GGRadio.OldSong = ""

timer.Create( "GGRadio_SongChange", 15, 0, function()
	if #player.GetAll() == 0 then return end

	http.Fetch( "https://api.tmw.media/ggradio/song/",
		function( body, len, headers, code )
			GGRadio.CurSong = string.Replace(body, "\n", "")
			if string.len(GGRadio.CurSong) > 200 then GGRadio.CurSong = "Song not available." end
			if(GGRadio.CurSong != GGRadio.OldSong) then
				GGRadio.OldSong = GGRadio.CurSong
				net.Start( "GGRadio_SongChanged" )
					net.WriteString( GGRadio.CurSong )
				net.Broadcast()
			end
		end,
		function( error )
			
		end);
end)

function GGRadio:UpdateCheck()
	http.Fetch( "http://cdn.tmw.media/ggradio/apps/gmod/version.php",
		function( body, len, headers, code )
			body = string.Replace( body, "\n", "" )
			if body ~= GGRadio.Version then
				GGRadio.Outdated = true
				print( "GGRadio has update available! (" .. body .. ")" )
			end
		end,
		function( error )
		
		end);
end

timer.Simple( 15, function()
	GGRadio:UpdateCheck()
end )

hook.Add( "PlayerInitialSpawn", "GGRadio_NotifyUpdate", function( ply )
	timer.Simple( 10, function()
		if not ply:IsAdmin() then return end
		if not GGRadio.Outdated then return end
		ply:ChatPrint( "GGRadio has update available!" )
	end )
end )

else

net.Receive("GGRadio_NewPresenter", function(len)
	local presenter = net.ReadString() or "Unknown"
	chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), presenter .. " is now live!" )
end)

net.Receive( "GGRadio_SongChanged", function( len )
	local song = net.ReadString() or "Unknown"
	chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Playing now: " .. song )
	chat.AddText( Color( 130, 130, 130 ), "[", Color( 255, 80, 0 ), "GG", Color( 130, 130, 130 ), "] ", Color( 255, 255, 255 ), "Type !radio to tune in to GGRadio.net" )
end )

end
